<?php

namespace itguild\forms\inputs;

use itguild\forms\templates\Template;

abstract class BaseInput
{
    protected Template $inputTemplate;
    protected bool $hasLabel = false;
    protected string $html;
    protected string $labelTitle = "";

    /**
     * @return void
     */
    public function render(): void
    {
        echo $this->html;
    }

    public abstract function create();

    /**
     * @param string $title
     * @return $this
     */
    public function setLabel(string $title): self
    {
        $this->hasLabel = true;
        $this->labelTitle = $title;

        return $this;
    }

    /**
     * @param $template
     * @return $this
     */
    public function setTemplate($template): self
    {
        $this->inputTemplate = new $template();

        return $this;
    }


}